//+------------------------------------------------------------------+
//|                                                  SR_Poddubny.mq4 |
//|                                                     |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright " "
#property link      ""
extern double nPips = 0.004;
extern double Lots=0.1;
int b;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  int Ans=false;
//----  
  int
  Total,
  Tip=-1,
  Ticket;
  double
  Lot,
  Lts,
  Min_lot,
  Step,
  Price;
  bool Fact_UP;        //     ! =)
  bool Fact_DN;



int shift = 0;
double cnt = 0;
double TrStopLevel = 0;
double PREV = 0;
 

// loop from first bar to current bar (with shift=0)
for(shift = Bars - 2; shift >= 1; shift--){ 
 
 
   if((Close[shift] == PREV)) {
      TrStopLevel=PREV;
   }else {
      if((Close[shift + 1]) < PREV && (Close[shift] < PREV)) {
         TrStopLevel=MathMin(PREV, Close[shift] * (1 + nPips));
      } else {
            if(((Close[shift + 1]) > PREV) && (Close[shift] > PREV)) {
               TrStopLevel = MathMax(PREV, Close[shift] * (1 - nPips));
            } else {
                  if((Close[shift] > PREV) ) {                   
                     TrStopLevel = Close[shift] * (1 - nPips);
                  } else {
                     TrStopLevel = Close[shift] * (1 + nPips);
                  }
            }
      }
   }
 
 
   if(Close[shift] > TrStopLevel && Close[shift + 1] < PREV && PREV != 0) {
        Fact_UP=true;
   } else {
        Fact_UP=false;
   }
 
 
   if( Close[shift] < TrStopLevel &&  Close[shift + 1]>PREV  && PREV != 0) {
        Fact_DN=true;
   } else {
        Fact_DN=false;
   }
 
 
   PREV = TrStopLevel;
} 
   
 
   
   b=Bars;
   
   //  
   string Symb=Symbol();                               //  ..
   Total=0;                                     //  
   for(int i=1; i<=OrdersTotal(); i++)          //   
     {
      if (OrderSelect(i-1,SELECT_BY_POS)==true) //   
        {                                       //  :
         if (OrderSymbol()!=Symb)continue;      //   . 
         if (OrderType()>1)                     //  
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Total++;                               //  . 
         if (Total>1)                           //    
           {
            Alert("  .   .");
            return;                             //   start()
           }
         Ticket=OrderTicket();                  //  . .
         Tip   =OrderType();                    //   .
         Price =OrderOpenPrice();               //  . .
         Lot   =OrderLots();                    //  
        }
     } 
   
   while(true)                                  //   .
     {
     
      if (Tip==0 && Fact_DN==true)                //   Buy..
        {                                       //   
         Alert("  Buy ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lots,Bid,0);      //  Buy
         if (Ans==true)                         //  :)
           {
            Alert ("  Buy ",Ticket);
            break;                              //    
           }
         return;                                //   start()
        }
 
      if (Tip==1 && Fact_UP==true)                //   Sell..
        {                                       //    
         Alert("  Sell ",Ticket,".  ..");
         RefreshRates();                        //  
         Ans=OrderClose(Ticket,Lots,Ask,0);      //  Sell
         if (Ans==true)                         //  :)
           {
            Alert ("  Sell ",Ticket);
            break;                              //    
           }
         return;                                //   start()
        }
      break;                                    //   while
     }   
     
//   ---------------------------------------------------+
      
   while(true)                                  //   .
     {
      if (Total==0 && Fact_UP==true)              //  .  +
        {                                       //  . Buy
         RefreshRates();                        //  
         Alert("  Buy.  ..");
         Ticket=OrderSend(Symb,OP_BUY,Lots,Ask,0,0,0);// Buy
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket);
            return;                             //   start()
           }
         return;                                //   start()
        }
      if (Total==0 && Fact_DN==true)              //  .  +
        {                                       //  . Sell
         RefreshRates();                        //  
         Alert("  Sell.  ..");
         Ticket=OrderSend(Symb,OP_SELL,Lots,Bid,0,0,0);// Sel
         if (Ticket > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket);
            return;                             //   start()
           }
         return;                                //   start()
        }
      break;                                    //   while
     }   
 }
//----
   return(0);
  
//+------------------------------------------------------------------+